Index: /trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 51294)
@@ -306,4 +306,10 @@
 endif
 
+# vbox-img
+if defined(VBOX_WITH_TESTCASES) || defined(VBOX_WITH_VBOX_IMG)
+  VBOX_LNX_STRIP_BIN += \
+	vbox-img
+endif
+
 # EFI firmware
 ifdef VBOX_WITH_EFIFW_PACKING
Index: /trunk/src/VBox/Installer/linux/debian/LocalConfig.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/debian/LocalConfig.kmk	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/debian/LocalConfig.kmk	(revision 51294)
@@ -30,2 +30,3 @@
 VBOX_PATH_APP_PRIVATE      := /usr/share/virtualbox
 VBOX_PATH_APP_DOCS          = $(VBOX_PATH_PACKAGE_DOCS)
+VBOX_WITH_VBOX_IMG         := 1
Index: /trunk/src/VBox/Installer/linux/deffiles
===================================================================
--- /trunk/src/VBox/Installer/linux/deffiles	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/deffiles	(revision 51294)
@@ -69,4 +69,5 @@
     vboxefi64.fv \
     vboxwebsrv \
+    vbox-img \
     components/comreg.dat \
     components/xpti.dat \
Index: /trunk/src/VBox/Installer/linux/install.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/install.sh	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/install.sh	(revision 51294)
@@ -112,4 +112,5 @@
     check_binary "/usr/bin/VBoxAutostart" "$install_dir" &&
     check_binary "/usr/bin/vboxwebsrv" "$install_dir"
+    check_binary "/usr/bin/vbox-img" "$install_dir"
 }
 
@@ -403,4 +404,5 @@
     ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/VBoxAutostart
     ln -sf $INSTALLATION_DIR/VBox.sh /usr/bin/vboxwebsrv
+    ln -sf $INSTALLATION_DIR/vbox-img /usr/bin/vbox-img
     ln -sf $INSTALLATION_DIR/VBox.png /usr/share/pixmaps/VBox.png
     # Unity and Nautilus seem to look here for their icons
Index: /trunk/src/VBox/Installer/linux/rpm/LocalConfig.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/rpm/LocalConfig.kmk	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/rpm/LocalConfig.kmk	(revision 51294)
@@ -29,4 +29,5 @@
 VBOX_PATH_APP_PRIVATE      := /usr/share/virtualbox
 VBOX_PATH_APP_DOCS          = $(VBOX_PATH_PACKAGE_DOCS)
+VBOX_WITH_VBOX_IMG         := 1
 
 # gcc 4.5 produces some more false positives
Index: /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec
===================================================================
--- /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 51294)
@@ -116,5 +116,5 @@
 rmdir icons
 mv virtualbox.xml $RPM_BUILD_ROOT/usr/share/mime/packages
-for i in VBoxManage VBoxSVC VBoxSDL VirtualBox VBoxHeadless VBoxExtPackHelperApp VBoxBalloonCtrl VBoxAutostart; do
+for i in VBoxManage VBoxSVC VBoxSDL VirtualBox VBoxHeadless VBoxExtPackHelperApp VBoxBalloonCtrl VBoxAutostart vbox-img; do
   mv $i $RPM_BUILD_ROOT/usr/lib/virtualbox; done
 if %WEBSVC%; then
@@ -195,4 +195,5 @@
 ln -s VBox $RPM_BUILD_ROOT/usr/bin/vboxautostart
 ln -s VBox $RPM_BUILD_ROOT/usr/bin/vboxwebsrv
+ln -s /usr/lib/virtualbox/vbox-img $RPM_BUILD_ROOT/usr/bin/vbox-img
 ln -s /usr/share/virtualbox/src/vboxhost $RPM_BUILD_ROOT/usr/src/vboxhost-%VER%
 mv virtualbox.desktop $RPM_BUILD_ROOT/usr/share/applications/virtualbox.desktop
Index: /trunk/src/VBox/Installer/linux/scripts/install.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/scripts/install.sh	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/scripts/install.sh	(revision 51294)
@@ -143,4 +143,7 @@
         NO_HELPERS="true"
         ;;
+    --no-vbox-img)
+        NO_VBOX_IMG="true"
+        ;;
     --python-command)
         test "${#}" -gt 1 ||
@@ -220,4 +223,6 @@
 test -n "${NO_WEB_SERVICE}" &&
     test ! -r "${INSTALL_SOURCE}/vboxwebsrv"
+test -n "${NO_VBOX_IMG}" &&
+    test ! -r "${INSTALL_SOURCE}/vbox-img"
 test -n "${NO_WEB_SERVICE}" &&
     test ! -r "${INSTALL_SOURCE}/webtest"
@@ -258,4 +263,6 @@
 ln -s "VBox" "${PREFIX}/bin/vboxautostart"
 test -z "${NO_WEB_SERVICE}" && ln -s "VBox" "${PREFIX}/bin/vboxwebsrv"
+echo "NO_VBOX_IMG = ${NO_VBOX_IMG}"
+test -z "${NO_VBOX_IMG}" && ln -sv "${RELATIVE_PREFIX}${INSTALL_FOLDER}/vbox-img" "${PREFIX}/bin/vbox-img"
 rmdir ${INSTALL_SOURCE}/additions
 rm "${INSTALL_SOURCE}/scripts/install.sh"
Index: /trunk/src/VBox/Installer/linux/uninstall.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/uninstall.sh	(revision 51293)
+++ /trunk/src/VBox/Installer/linux/uninstall.sh	(revision 51294)
@@ -103,4 +103,5 @@
   /usr/bin/VBoxNetNAT \
   /usr/bin/vboxwebsrv \
+  /usr/bin/vbox-img \
   /usr/bin/VBoxAddIF \
   /usr/bin/VBoxDeleteIf \