Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 51440)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 51446)
@@ -40,8 +40,4 @@
 const char* UIExtraDataDefs::GUI_FirstRun = "GUI/FirstRun";
 const char* UIExtraDataDefs::GUI_HideDescriptionForWizards = "GUI/HideDescriptionForWizards";
-const char* UIExtraDataDefs::GUI_Export_StorageType = "GUI/Export/StorageType";
-const char* UIExtraDataDefs::GUI_Export_Username = "GUI/Export/Username";
-const char* UIExtraDataDefs::GUI_Export_Hostname = "GUI/Export/Hostname";
-const char* UIExtraDataDefs::GUI_Export_Bucket = "GUI/Export/Bucket";
 
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 51440)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 51446)
@@ -48,8 +48,4 @@
     extern const char* GUI_FirstRun;
     extern const char* GUI_HideDescriptionForWizards;
-    extern const char* GUI_Export_StorageType;
-    extern const char* GUI_Export_Username;
-    extern const char* GUI_Export_Hostname;
-    extern const char* GUI_Export_Bucket;
 
 #ifdef VBOX_GUI_WITH_NETWORK_MANAGER
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp	(revision 51440)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp	(revision 51446)
@@ -121,17 +121,5 @@
 
     /* Export the VMs, on success we are finished: */
-    if (exportVMs(*pAppliance))
-    {
-#if 0
-        /* Save attributes to GUI extra data: */
-        StorageType storageType = field("storageType").value<StorageType>();
-        vboxGlobal().virtualBox().SetExtraData(GUI_Export_StorageType, QString::number(storageType));
-        vboxGlobal().virtualBox().SetExtraData(GUI_Export_Username, m_pLeUsername->text());
-        vboxGlobal().virtualBox().SetExtraData(GUI_Export_Hostname, m_pLeHostname->text());
-        vboxGlobal().virtualBox().SetExtraData(GUI_Export_Bucket, m_pLeBucket->text());
-#endif
-        return true;
-    }
-    return false;
+    return exportVMs(*pAppliance);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 51440)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 51446)
@@ -34,15 +34,6 @@
 void UIWizardExportAppPage2::chooseDefaultStorageType()
 {
-    /* Select default storage type: */
-#if 0
-    /* Load storage-type from GUI extra data: */
-    bool ok;
-    StorageType storageType = StorageType(vboxGlobal().virtualBox().GetExtraData(GUI_Export_StorageType).toInt(&ok));
-    if (ok)
-        setStorageType(storageType);
-#else
     /* Just select first of types: */
     setStorageType(Filesystem);
-#endif
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 51440)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 51446)
@@ -41,13 +41,6 @@
 void UIWizardExportAppPage3::chooseDefaultSettings()
 {
-    /* Select default settings: */
-#if 0
-    m_pUsernameEditor->setText(vboxGlobal().virtualBox().GetExtraData(GUI_Export_Username));
-    m_pHostnameEditor->setText(vboxGlobal().virtualBox().GetExtraData(GUI_Export_Hostname));
-    m_pBucketEditor->setText(vboxGlobal().virtualBox().GetExtraData(GUI_Export_Bucket));
-#else
-    /* Choose defalt format: */
+    /* Choose default format: */
     setFormat("ovf-1.0");
-#endif
 }
 