Index: trunk/src/VBox/NetworkServices/NAT/fwtcp.c
===================================================================
--- trunk/src/VBox/NetworkServices/NAT/fwtcp.c	(revision 51575)
+++ trunk/src/VBox/NetworkServices/NAT/fwtcp.c	(revision 51576)
@@ -202,6 +202,4 @@
     struct sockaddr_storage ss;
     socklen_t sslen;
-    void *peer_addr;
-    uint16_t peer_port;
     struct pxtcp *pxtcp;
     SOCKET newsock;
@@ -229,28 +227,12 @@
     if (ss.ss_family == PF_INET) {
         struct sockaddr_in *peer4 = (struct sockaddr_in *)&ss;
-        peer_addr = &peer4->sin_addr;
-        peer_port = peer4->sin_port;
+        DPRINTF(("<--- TCP %RTnaipv4:%d\n",
+                 peer4->sin_addr.s_addr, ntohs(peer4->sin_port)));
     }
     else { /* PF_INET6 */
         struct sockaddr_in6 *peer6 = (struct sockaddr_in6 *)&ss;
-        peer_addr = &peer6->sin6_addr;
-        peer_port = peer6->sin6_port;
-    }
-    peer_port = ntohs(peer_port);
-
-#if PLEASE_ABSTAIN_FROM_DPRINFING > 1 /* DPRINTF */ && !defined(RT_OS_WINDOWS)
-    {
-        char addrbuf[sizeof "ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255"];
-        const char *addrstr;
-
-        addrstr = inet_ntop(ss.ss_family, peer_addr, addrbuf, sizeof(addrbuf));
-        DPRINTF(("<--- TCP %s%s%s:%d\n",
-                 ss.ss_family == AF_INET6 ? "[" : "",
-                 addrstr,
-                 ss.ss_family == AF_INET6 ? "]" : "",
-                 peer_port));
-    }
-#endif  /* DPRINTF */
-
+        DPRINTF(("<--- TCP %RTnaipv6:%d\n",
+                 &peer6->sin6_addr, ntohs(peer6->sin6_port)));
+    }
 
     pxtcp = pxtcp_create_forwarded(newsock);
Index: trunk/src/VBox/NetworkServices/NAT/proxy.c
===================================================================
--- trunk/src/VBox/NetworkServices/NAT/proxy.c	(revision 51575)
+++ trunk/src/VBox/NetworkServices/NAT/proxy.c	(revision 51576)
@@ -250,4 +250,5 @@
     LWIP_ASSERT1(stype == SOCK_STREAM || stype == SOCK_DGRAM);
 
+    DPRINTF(("---> %s ", stype == SOCK_STREAM ? "TCP" : "UDP"));
     if (sdom == PF_INET6) {
         pdst_sa = (struct sockaddr *)&dst_sin6;
@@ -262,4 +263,6 @@
         memcpy(&dst_sin6.sin6_addr, &dst_addr->ip6, sizeof(ip6_addr_t));
         dst_sin6.sin6_port = htons(dst_port);
+
+        DPRINTF(("[%RTnaipv6]:%d ", &dst_sin6.sin6_addr, dst_port));
     }
     else { /* sdom = PF_INET */
@@ -275,20 +278,7 @@
         dst_sin.sin_addr.s_addr = dst_addr->ip4.addr; /* byte-order? */
         dst_sin.sin_port = htons(dst_port);
-    }
-
-#if LWIP_PROXY_DEBUG && !RT_OS_WINDOWS
-    {
-        char addrbuf[sizeof "ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255"];
-        const char *addrstr;
-
-        addrstr = inet_ntop(sdom, pdst_addr, addrbuf, sizeof(addrbuf));
-        DPRINTF(("---> %s %s%s%s:%d ",
-                 stype == SOCK_STREAM ? "TCP" : "UDP",
-                 sdom == PF_INET6 ? "[" : "",
-                 addrstr,
-                 sdom == PF_INET6 ? "]" : "",
-                 dst_port));
-    }
-#endif
+
+        DPRINTF(("%RTnaipv4:%d ", dst_sin.sin_addr.s_addr, dst_port));
+    }
 
     s = proxy_create_socket(sdom, stype);
Index: trunk/src/VBox/NetworkServices/NAT/winutils.h
===================================================================
--- trunk/src/VBox/NetworkServices/NAT/winutils.h	(revision 51575)
+++ trunk/src/VBox/NetworkServices/NAT/winutils.h	(revision 51576)
@@ -36,48 +36,4 @@
 #  define __func__ __FUNCTION__
 #  define __attribute__(x) /* IGNORE */
-
-/*
- * XXX: inet_ntop() is only available starting from Vista.
- */
-DECLINLINE(PCSTR)
-inet_ntop(INT Family, PVOID pAddr, PSTR pStringBuf, size_t StringBufSize)
-{
-    DWORD size = (DWORD)StringBufSize;
-    int status;
-
-    if (Family == AF_INET)
-    {
-        struct sockaddr_in sin;
-        memset(&sin, 0, sizeof(sin));
-        sin.sin_family = AF_INET;
-        memcpy(&sin.sin_addr, pAddr, sizeof(sin.sin_addr));
-        sin.sin_port = 0;
-        status = WSAAddressToStringA((LPSOCKADDR)&sin, sizeof(sin), NULL,
-                                     pStringBuf, &size);
-    }
-    else if (Family == AF_INET6)
-    {
-        struct sockaddr_in6 sin6;
-        memset(&sin6, 0, sizeof(sin6));
-        sin6.sin6_family = AF_INET6;
-        memcpy(&sin6.sin6_addr, pAddr, sizeof(sin6.sin6_addr));
-        sin6.sin6_port = 0;
-        status = WSAAddressToStringA((LPSOCKADDR)&sin6, sizeof(sin6), NULL,
-                                     pStringBuf, &size);
-    }
-    else
-    {
-        WSASetLastError(WSAEAFNOSUPPORT);
-        return NULL;
-    }
-
-    if (status == SOCKET_ERROR)
-    {
-        return NULL;
-    }
-
-    return pStringBuf;
-}
-
 
 /**